version: "2.1"
services:
  postgres:
    image: postgres:{{ postgres_docker_img_version }}
    container_name: {{ postgres_container_name }}
    restart: always
    environment:
      POSTGRES_USER: {{ db_user }}
      POSTGRES_PASSWORD: {{ db_password }}
      POSTGRES_DB : {{ db_name }}
      POSTGRES_PORT : {{ db_port }}
      KEYCLOAK_DB: {{ keycloak_db }}
      KEYCLOAK_DB_USER: {{ keycloak_db_user }}
      KEYCLOAK_DB_PASSWORD: {{ keycloak_db_password }}
    healthcheck:
      test: 'PGPASSWORD="{{ keycloak_db_password }}" psql --host 127.0.0.1 --username {{ keycloak_db_user }} --dbname {{ keycloak_db }} -c "select 1" ; [ "0" -eq "$$?" ]; echo $$?'
      interval: 30s
      timeout: 10s
      retries: 3
{% if expose_db_port is defined | default(false) %}
    ports:
      - "{{ expose_db_port }}:{{ db_port }}"
{% endif %}
    volumes:
      - {{ postgresql_data_path }}:/var/lib/postgresql/data
      - /home/{{ opencell_user }}/input-files/init-user-db.sh:/docker-entrypoint-initdb.d/init-user-db.sh
      - /home/{{ opencell_user }}/input-files/import-postgres.sql:/docker-entrypoint-initdb.d/import-postgres.sql
    # TODO: Create directory from ansible for postgres logs.
    # TODO: Configure postgres to print logs to somewhere promtail can read them
    # TODO: Configure promtail to read postgres logfiles
    # volumes:
    #  - /home/{{ opencell_user }}/postgres-log:/var/log/postgres/

  opencell:
    image: opencell/wildfly-opencell:{{ opencell_docker_img_version }}
    container_name: {{ opencell_container_name }}
    restart: always
    depends_on:
      postgres:
        condition: service_healthy
    environment:
      KEYCLOAK_URL: {{ base_url }}/auth
      WILDFLY_PROXY_ADDRESS_FORWARDING: "true"
      DB_HOST: postgres
      DB_USER: {{ db_user }}
      DB_PASSWORD: {{ db_password }}
      DB_NAME : {{ db_name }}
      DB_PORT : {{ db_port }}
      KEYCLOAK_DB: {{ keycloak_db }}
      KEYCLOAK_DB_USER: {{ keycloak_db_user }}
      KEYCLOAK_DB_PASSWORD: {{ keycloak_db_password }}
      KEYCLOAK_DB_HOST: postgres
      KEYCLOAK_ADMIN_USER: {{ keycloak_admin_user }}
      KEYCLOAK_ADMIN_PASSWORD: {{ keycloak_admin_password }}
      OPENCELL_LOG_LEVEL: "{{ opencell_log_level }}"
      OPENCELL_DEBUG_LEVEL: "DEBUG"
{% if opencell_monitoring_enabled | default(false) %}
      ENABLE_GLOWROOT_APM: "true"
{% endif %}
{% if opencell_mail_enabled | default(false) %}
      SMTP_TLS : "true"
      SMTP_HOST: "{{ opencell_smtp_host }}"
      SMTP_PORT: "{{ opencell_smtp_port }}"
      SMTP_FROM: "{{ opencell_smtp_from }}"
      SMTP_USERNAME: "{{ opencell_smtp_username }}"
      SMTP_PASSWORD: "{{ opencell_smtp_password }}"
{% endif %}
    ports:
{% if development_environment | default(false) %}
      - "8080:8080"
{% else %}
      - "127.0.0.1:8080:8080"
{% endif %}
{% if opencell_monitoring_enabled | default(false) %}
      - "127.0.0.1:4000:4000"
{% endif %}
    volumes:
      - /home/{{ opencell_user }}/input-files/opencell.war:/opt/jboss/wildfly/standalone/deployments/opencell.war
      - /home/{{ opencell_user }}/input-files/opencell-admin.properties:/opt/jboss/wildfly/standalone/configuration/opencell-admin.properties
      - {{ opencell_data_path }}:/opt/jboss/opencelldata
      # Template used by the COM invoices
      - {{ invoice_template_project_path }}/logo.png:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/logo.png
      - {{ invoice_template_project_path }}/invoice.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice.jasper
      - {{ invoice_template_project_path }}/invoice_categories.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice_categories.jasper
      - {{ invoice_template_project_path }}/invoice_categoriesADJ.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice_categoriesADJ.jasper
      - {{ invoice_template_project_path }}/invoice_details.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice_details.jasper
      - {{ invoice_template_project_path }}/invoice_lines_without_taxes.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice_lines_without_taxes.jasper
      - {{ invoice_template_project_path }}/invoice_lines.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/pdf/invoice_lines.jasper
      # Template used by the ADJ invoices
      - {{ invoice_template_project_path }}/logo.png:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/logo.png
      - {{ invoice_template_project_path }}/invoice.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/invoice.jasper
      - {{ invoice_template_project_path }}/invoice_categories.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/invoice_categories.jasper
      - {{ invoice_template_project_path }}/invoice_categoriesADJ.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/invoice_categoriesADJ.jasper
      - {{ invoice_template_project_path }}/invoice_details.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/invoice_details.jasper
      - {{ invoice_template_project_path }}/invoice_lines.jasper:/opt/jboss/opencelldata/default/jasper/TELECOM/invoiceAdjustmentPdf/invoice_lines.jasper
      # Template locales
      - {{ invoice_template_project_path }}/i18n.properties:/opt/jboss/i18n.properties
      - {{ invoice_template_project_path }}/i18n_ca.properties:/opt/jboss/i18n_ca.properties
      - {{ invoice_template_project_path }}/i18n_es.properties:/opt/jboss/i18n_es.properties
      # TODO: Remove this line when the problem with the locales was solved. It's only a workaround.
      - {{ invoice_template_project_path }}/i18n_es.properties:/opt/jboss/i18n_fr.properties
      - {{ opencell_logs_path }}:/opt/jboss/wildfly/standalone/log
{% if opencell_monitoring_enabled | default(false) %}
      - /home/{{ opencell_user }}/glowroot_admin.json:/opt/jboss/glowroot/admin.json
{% endif %}
